/***********************************************************************/
/*                                                                     */
/*  FILE        :LogicAnalyze.c                                        */
/*  DATE        :Mon, Jul 27, 2009                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3687                                               */
/*                                                                     */
/*  This file is programed by TOYO-LINX Co.,Ltd. / yKikuchi            */
/*                                                                     */
/***********************************************************************/

/************************************************************************
	
************************************************************************/
/*
2009-07-27 : vOX^[g
*/

/************************************************************************
	OQƐ錾
************************************************************************/

/************************************************************************
	CN[ht@C
************************************************************************/
#include	<machine.h>		//H8L̖߂g
#include	"iodefine.h"	//I/Õx`
#include	"binary.h"		//C2ig߂̒`

/************************************************************************
	萔̒`iڎwj
************************************************************************/
#define		OK			0		//߂l
#define		NG			-1		//߂l

// |[g ---------------------------------------------------------------
#define		LogicPort	IO.PDR7.BYTE	//WbN̓|[gԍ

//TvO ----------------------------------------------------------
#define		SamplingConst	1024	//TvO

//\tgEFA^C} ----------------------------------------------------
#define		T0			100		//T0(100ms)	:
#define		T1			100		//T1(100ms)	:
#define		T2			100		//T2(100ms)	:
#define		T3			100		//T3(100ms)	:
#define		T4			100		//T4(100ms)	:
#define		T5			100		//T5(100ms)	:
#define		T6			100		//T6(100ms)	:
#define		T7			100		//T7(100ms)	:

//ʐM ------------------------------------------------------------------
#define		RXBUF_SIZE	256		//RxBuf̃TCY
#define		CMD_SIZE	24		//R}h̍őTCY
#define		CR			0x0d	//Carriage Return
#define		LEN_01		17		//R}h : ADl擾Jn

/************************************************************************
	萔GA̒`(ROM)
************************************************************************/

/************************************************************************
	O[oϐ̒`ƃCjVCY(RAM)
************************************************************************/
// ADϊɊ֌Wϐ -------------------------------------------------
unsigned char	LogicBuf[SamplingConst];	//WbNobt@

unsigned char	ChEnable[8];		//WbN̓Cl[u`l
unsigned char	TriggerCh;			//gK`l
unsigned char	TriggerMode;		//gK[h
									// 0:I[g 1:GbW
unsigned char	TriggerSlope;		//gKX[v
									// 0:vXGbW 1:}CiXGbW
unsigned int	TriggerLevel;		//gKx
unsigned char	TimeDiv;			//Time/Div
									// 0:  1ms/div  1:  2ms/div  2:  5ms/div
									// 3: 10ms/div  4: 20ms/div  5: 50ms/div
									// 6:100ms/div  7:200ms/div  8:500ms/div

unsigned char	DsoStatus;			//DSOXe[^X
									// 0:~
									// 1:X^[gw
									// 2:gKĎ
									// 3:ADl擾
									// 4:I

unsigned int	SamplingCount;		//TvOJE^
unsigned int	SamplingCount2;		//TvOJE^-2
unsigned char	AdChannel;			//ADϊĂ`l

unsigned char	TriggerStatus;		//gKXe[^X
									// 0:
									// 1:gK҂
unsigned char	TriggerPort;		//gKĎ|[g
unsigned char	TriggerEdge1;		//gKĎGbW1
unsigned char	TriggerEdge2;		//gKĎGbW2

// \tgEFA^C}Ɋ֌Wϐ -------------------------------------
struct SoftTimer{					//\tgEFA^C}̍\̃^O
	unsigned char	Status;			//^C}Xe[^X
									// 0:~(^C}gp)
									// 1:X^[gw
									// 2:JEg
									// 3:JEgI
	unsigned int	Count;			//^C}JE^
};
struct SoftTimer TimT0;				//T0^C}
struct SoftTimer TimT1;				//T1^C}
struct SoftTimer TimT2;				//T2^C}
struct SoftTimer TimT3;				//T3^C}
struct SoftTimer TimT4;				//T4^C}
struct SoftTimer TimT5;				//T5^C}
struct SoftTimer TimT6;				//T6^C}
struct SoftTimer TimT7;				//T7^C}

// ʐMɊ֌Wϐ ---------------------------------------------------
unsigned char	RxBuf[RXBUF_SIZE];	//Mobt@
unsigned char	*RxBufWrPnt;		//Mobt@Cg|C^
unsigned char	*RxBufRdPnt;		//Mobt@[h|C^
unsigned char	*RxBufMin;			//Mobt@̍ŏ
unsigned char	*RxBufMax;			//Mobt@̍Ō
unsigned char	RxCmd[CMD_SIZE];	//MR}h
unsigned char	HeaderData;			//wb_


/************************************************************************
	֐̒`
************************************************************************/
unsigned char	asc2hex(unsigned int);
void			analyze_rxcmd(void);
int				chk_command(unsigned char,unsigned int);
void			dso_cont(void);
void			dec_soft_timer(struct SoftTimer *,unsigned int);
void			get_command(unsigned int);
int				get_rxbuf(unsigned char *);
unsigned int	hex2asc(unsigned char);
void			init_io(void);
void			init_rxbuf(void);
void			init_sci3(void);
void			init_soft_timer(void);
void			init_tmb1(void);
//void			init_tmv(void);
void			init_tmz(void);
void			intprog_sci3(void);
void			intprog_tmb1(void);
//void			intprog_tmv(void);
void			intprog_tmz0(void);
void			main(void);
int				put_rxbuf(unsigned char);
void			rxerr_sci3(void);
void			rxdata_sci3(void);
unsigned char	rxone(void);
void			sampling_start(void);
void			trigger_watch(void);
void			tx_ad_data(void);
void			txone(unsigned char);
void			wait(void);

/************************************************************************
	CvO
************************************************************************/
void main(void)
{
	// CjVCY ----------------------------------------------------
	init_io();
	init_tmb1();
	init_soft_timer();
//	init_tmz();
	init_sci3();
	init_rxbuf();

	// C[v -----------------------------------------------------
	while(1){
		analyze_rxcmd();	//Mf[^`FbN
		dso_cont();			//DSO
	}
}

/************************************************************************
	DSO
************************************************************************/
void dso_cont(void)
{
	unsigned int i;
	
	switch(DsoStatus){
		//ҋ@ ------------------------------------------------------
		case 0:
			break;
		//X^[gw ------------------------------------------------
		case 1:
			for(i=0; i<SamplingConst; i++) {LogicBuf[i] = 0;}
			if (TriggerMode==0){	//I[ggK
				sampling_start();
				DsoStatus = 3;
			}
			else{					//GbWgK
				TriggerStatus = 0;
				TriggerPort = _00000001B << TriggerCh;
				if (TriggerSlope==0){
					TriggerEdge1 = _00000000B;
					TriggerEdge2 = TriggerPort;
				}
				else{
					TriggerEdge1 = TriggerPort;
					TriggerEdge2 = _00000000B;
				}
				DsoStatus = 2;
			}
			break;
		//gKĎ --------------------------------------------------
		case 2:
			trigger_watch();
			break;
		//ADl擾 --------------------------------------------------
		case 3:
			break;
		//I --------------------------------------------------------
		case 4:
			tx_ad_data();	//ADf[^̑M
			DsoStatus = 0;
			break;
		//-------------------------------------------------------------
		default:
			break;
	}
}

/************************************************************************
	TvOX^[g
************************************************************************/
void sampling_start(void)
{
	SamplingCount = SamplingConst;
	if		(ChEnable[7]==1)	{SamplingCount2 = 1;}
	else if	(ChEnable[3]==1)	{SamplingCount2 = 2;}
	else if	(ChEnable[1]==1)	{SamplingCount2 = 4;}
	else						{SamplingCount2 = 8;}

	init_tmz();
}

/************************************************************************
	gK̊Ď
************************************************************************/
void trigger_watch(void)
{
	unsigned char d;

	d = LogicPort & TriggerPort;
	
	if(TriggerStatus==0){
		if(d==TriggerEdge1){
			TriggerStatus = 1;
		}
	}
	else{
		if(d==TriggerEdge2){
//			IO.PDR6.BIT.B0 = 1;
			TriggerStatus = 0;
			sampling_start();
			DsoStatus = 3;
//			IO.PDR6.BIT.B0 = 0;
			return;
		}
	}

}

/************************************************************************
	ADf[^̑M
************************************************************************/
void tx_ad_data(void)
{
	unsigned int j,d;
	
	txone('%');
	txone('0');
	txone(',');
	for (j=0; j<SamplingConst; j++){
		d = hex2asc(LogicBuf[j]);
		txone(d / 0x0100);
		txone(d & 0x00ff);
	}
	txone(CR);
}

/************************************************************************
	^C}Z CjVCYi^C}X^[gj
************************************************************************/
void init_tmz(void)
{
	TZ.TSTR.BYTE	=	_00000000B;	//TCNT0,1 ~
	switch (TimeDiv){
		case 0:		//  1ms/Div
		case 1:		//  2ms/Div
		case 2:		//  5ms/Div
		case 3:		// 10ms/Div
		case 4:		// 20ms/Div
		case 5:		// 50ms/Div
			TZ0.TCR.BYTE	=	_00100000B;	//GRÃRyA}b`NA,/1
			break;
		case 6:		//100ms/Div
			TZ0.TCR.BYTE	=	_00100001B;	//GRÃRyA}b`NA,/2
			break;
		case 7:		//200ms/Div
			TZ0.TCR.BYTE	=	_00100010B;	//GRÃRyA}b`NA,/4
			break;
		case 8:		//500ms/Div
			TZ0.TCR.BYTE	=	_00100011B;	//GRÃRyA}b`NA,/8
			break;
		default:	//0.5ms/Div
			TZ0.TCR.BYTE	=	_00100000B;	//GRÃRyA}b`NA,/1
			break;
	}
	TZ.TOER.BYTE	=	_11111111B;	//o͒[qfBZ[u
	TZ0.TSR.BYTE	=	_00000000B;	//݃tONA
	TZ0.TIER.BYTE	=	_00000001B;	//GRAC^[vgCl[u
	switch (TimeDiv){
		case 0:		//  1ms/Div
			TZ0.GRA		=	800;	//tF[Y̎(40us)
			break;
		case 1:		//  2ms/Div
			TZ0.GRA		=	1600;	//tF[Y̎(80us)
			break;
		case 2:		//  5ms/Div
			TZ0.GRA		=	4000;	//tF[Y̎(200us)
			break;
		case 3:		// 10ms/Div
			TZ0.GRA		=	8000;	//tF[Y̎(400us)
			break;
		case 4:		// 20ms/Div
			TZ0.GRA		=	16000;	//tF[Y̎(800us)
			break;
		case 5:		// 50ms/Div
			TZ0.GRA		=	40000;	//tF[Y̎(2000us=2ms)
			break;
		case 6:		//100ms/Div
			TZ0.GRA		=	40000;	//tF[Y̎(4000us=4ms)
			break;
		case 7:		//200ms/Div
			TZ0.GRA		=	40000;	//tF[Y̎(8000us=8ms)
			break;
		case 8:		//500ms/Div
			TZ0.GRA		=	50000;	//tF[Y̎(20000us=20ms)
			break;
		default:	//0.5ms/Div
			TZ0.GRA		=	400;	//tF[Y̎(20us)
			break;
	}
	TZ0.TCNT		=	0x0000;		//TCNT0=0
	TZ.TSTR.BYTE	=	_00000001B;	//TCNT0 JEgX^[g
}

/************************************************************************
	^C}Z `l0 
************************************************************************/
#pragma regsave (intprog_tmz0)
void intprog_tmz0(void)
{
	unsigned char d;
	
//	IO.PDR6.BIT.B1 = 1;

	TZ0.TSR.BIT.IMFA = 0;	//^C}Z `l0 RyA}b`tOA NA
		
	d = LogicPort;
	
	if (ChEnable[7]==1){
		LogicBuf[SamplingConst - SamplingCount] = d;
	}
	else if (ChEnable[3]==1){
		if (SamplingCount2==2){
			LogicBuf[SamplingConst - SamplingCount] = d & _00001111B;
		}
		else{
			LogicBuf[SamplingConst - SamplingCount] = LogicBuf[SamplingConst - SamplingCount] | ((d & _00001111B) * 0x10);
		}
	}
	else if (ChEnable[1]==1){
		if (SamplingCount2==4){
			LogicBuf[SamplingConst - SamplingCount] = d & _00000011B;
		}
		else if (SamplingCount2==3){
			LogicBuf[SamplingConst - SamplingCount] = LogicBuf[SamplingConst - SamplingCount] | ((d & _00000011B) * 0x04);
		}
		else if (SamplingCount2==2){
			LogicBuf[SamplingConst - SamplingCount] = LogicBuf[SamplingConst - SamplingCount] | ((d & _00000011B) * 0x10);
		}
		else{
			LogicBuf[SamplingConst - SamplingCount] = LogicBuf[SamplingConst - SamplingCount] | ((d & _00000011B) * 0x40);
		}
	}
	else{
		if (SamplingCount2==8){
			LogicBuf[SamplingConst - SamplingCount] = d & _00000001B;
		}
		else if (SamplingCount2==7){
			LogicBuf[SamplingConst - SamplingCount] = LogicBuf[SamplingConst - SamplingCount] | ((d & _00000001B) * 0x02);
		}
		else if (SamplingCount2==6){
			LogicBuf[SamplingConst - SamplingCount] = LogicBuf[SamplingConst - SamplingCount] | ((d & _00000001B) * 0x04);
		}
		else if (SamplingCount2==5){
			LogicBuf[SamplingConst - SamplingCount] = LogicBuf[SamplingConst - SamplingCount] | ((d & _00000001B) * 0x08);
		}
		else if (SamplingCount2==4){
			LogicBuf[SamplingConst - SamplingCount] = LogicBuf[SamplingConst - SamplingCount] | ((d & _00000001B) * 0x10);
		}
		else if (SamplingCount2==3){
			LogicBuf[SamplingConst - SamplingCount] = LogicBuf[SamplingConst - SamplingCount] | ((d & _00000001B) * 0x20);
		}
		else if (SamplingCount2==2){
			LogicBuf[SamplingConst - SamplingCount] = LogicBuf[SamplingConst - SamplingCount] | ((d & _00000001B) * 0x40);
		}
		else{
			LogicBuf[SamplingConst - SamplingCount] = LogicBuf[SamplingConst - SamplingCount] | ((d & _00000001B) * 0x80);
		}
	}

	SamplingCount = SamplingCount - 1;
	if (SamplingCount==0){
		SamplingCount2 = SamplingCount2 - 1;
		if (SamplingCount2==0){
			TZ.TSTR.BYTE	=	0x00;	//TCNT0,1 ~
			TZ0.TIER.BYTE	=	0x00;	//GRAC^[vgfBZ[u
			TZ0.TCNT		=	0x0000;	//TCNT0=0
			DsoStatus = 4;
		}
		else{
			SamplingCount = SamplingConst;
		}
	}

//	IO.PDR6.BIT.B1 = 0;

}

/************************************************************************
	MR}h
************************************************************************/
void analyze_rxcmd(void)
{
	unsigned char data;		//RxBufof[^
	unsigned int len;		//R}h
	unsigned int i;

	if (get_rxbuf(&data)==NG) {return;}	//Mf[^Ȃ

	//R}hM`FbN
	if (data=='/'){		//LZ
		TZ.TSTR.BYTE	=	0x00;	//TCNT0,1 ~
		TZ0.TIER.BYTE	=	0x00;	//GRAC^[vgfBZ[u
		TZ0.TCNT		=	0x0000;	//TCNT0=0
		HeaderData = 0x00;
		DsoStatus = 0;
	}
	else if (data==CR){	//IR[hM
		if      (HeaderData=='#')	{len = LEN_01;}
		else						{HeaderData = 0x00; return;}
		get_command(len);
		if (chk_command(HeaderData,len)==NG) {HeaderData = 0x00; return;}
	}
	else if (data=='#'){	//wb_M
		HeaderData = '#';
		return;
	}
	else{
		return;
	}

	//KR}hM,̓`lgKQbg
	for(i=0;i<8;i++){
		ChEnable[i] = RxCmd[i+1] - 0x30;
	}
	TriggerCh		=	RxCmd[10] - 0x30 - 1;
	TriggerMode		=	RxCmd[11] - 0x30;
	TriggerSlope	=	RxCmd[12] - 0x30;
	TimeDiv			=	asc2hex(RxCmd[14] * 0x100 + RxCmd[15]);

	//WbN擾w
	DsoStatus = 1;
}

/************************************************************************
	RxBuf R}ho
-------------------------------------------------------------------------
			len			R}h
************************************************************************/
void get_command(unsigned int len)
{
	unsigned char *pa;		//RxBuf̃|C^
	unsigned char *pb;		//RxCmd̃|C^
	int i;

	pa = RxBufRdPnt;
	pb = RxCmd+len-1;

	//RxBuf̍Ōɒ~f[^(len)oCg RxCmdɈڂ
	for(i=len;i!=0;i--){
		pa--;if (pa<RxBufMin) pa=RxBufMax;
		*pb = *pa;
		pb--;
	}
}

/************************************************************************
	K̃R}h`FbN
	f[^,wb_`FbN
-------------------------------------------------------------------------
			cmd			R}h̎
			len			R}h
-------------------------------------------------------------------------
	߂l	OK			KR}h
			NG			G[
************************************************************************/
int chk_command(unsigned char cmd,unsigned int len)
{
	unsigned char *pa;		//RxCmd̃|C^

	pa = RxCmd;

	switch (cmd){
		case '#':	//wb_`FbN
			if (*pa!='#') return NG;
			if (len!=LEN_01) return NG;
			return OK;
			break;
		default:
			return NG;
	}
}

/************************************************************************
	RxBuf ̏
************************************************************************/
void init_rxbuf(void)
{
	RxBufRdPnt	=	RxBuf;				//Mobt@[h|C^Zbg
	RxBufWrPnt	=	RxBufRdPnt;			//Mobt@Cg|C^Zbg
	RxBufMin	=	RxBuf;				//Mobt@̍ŏZbg
	RxBufMax	=	RxBuf+RXBUF_SIZE-1;	//Mobt@̍ŌZbg
	HeaderData	=	0x00;				//wb_f[^NA
}

/************************************************************************
	RxBuf Ƀf[^i[
-------------------------------------------------------------------------
			data		RxBufɊi[f[^
-------------------------------------------------------------------------
	߂l	OK			i[ł
			NG			G[,obt@炠ӂꂽ
************************************************************************/
int put_rxbuf(unsigned char data)
{
	int ret_code;	//OK or NG

	if ((RxBufRdPnt==RxBufMin && RxBufWrPnt==RxBufMax) || RxBufWrPnt==RxBufRdPnt-1)
		ret_code = NG;		//obt@TCYz
	else{
		*RxBufWrPnt = data;
		RxBufWrPnt++;
		if (RxBufWrPnt>RxBufMax)
			RxBufWrPnt=RxBufMin;	//Cg|C^擪ɖ߂
		ret_code = OK;
	}
	return ret_code;
}

/************************************************************************
	RxBuf f[^o
-------------------------------------------------------------------------
			*pd			of[^Zbg|C^
-------------------------------------------------------------------------
	߂l	OK			o
			NG			G[,obt@ɉĂȂ
************************************************************************/
int get_rxbuf(unsigned char *pd)
{
	int ret_code;

	if (RxBufWrPnt==RxBufRdPnt)
		ret_code = NG;		//obt@ɉĂȂ
	else{
		*pd = *RxBufRdPnt;
		RxBufRdPnt++;
		if (RxBufRdPnt>RxBufMax)
			RxBufRdPnt=RxBufMin;	//[h|C^擪ɖ߂
		ret_code = OK;
	}
	return ret_code;
}

/************************************************************************
	SCI3 CjVCY
************************************************************************/
void init_sci3(void)
{
	#define		MHz		20			// Clock=20MHz
	#define		BAUD	38400		// baudrate
	#define		BITR	(MHz*1000000)/(BAUD*32)-1
	#define		WAIT_1B	(MHz*1000000)/6/BAUD

	unsigned	long	i;

	IO.PMR1.BIT.TXD	=	1;			//TxD[qCl[u
	SCI3.SCR3.BYTE	=	0x00;		//~
	SCI3.SMR .BYTE	=	0x00;		//,8bit,NonParity,StopBit=1
	SCI3.BRR		=	BITR;		//ޯڰ
	for	(i=0;i<WAIT_1B;i++){};		//1bit wait
	SCI3.SCR3.BYTE	=	0x70;		//MCl[u,M荞݃Cl[u
}

/************************************************************************
	SCI3 ݁iݗvɂĐU蕪j
************************************************************************/
#pragma regsave (intprog_sci3)
void intprog_sci3(void)
{
	if (SCI3.SSR.BIT.OER==1
	 || SCI3.SSR.BIT.FER==1
	 || SCI3.SSR.BIT.PER==1)		rxerr_sci3();	//MG[
	else if (SCI3.SSR.BIT.RDRF==1)	rxdata_sci3();	//M
//	else if (SCI3.SSR.BIT.TEND==1)	txend_sci3();	//MI
//	else if (SCI3.SSR.BIT.TDRE==1)	txdata_sci3();	//M
}

/************************************************************************
	SCI3 MG[
************************************************************************/
void rxerr_sci3(void)
{
	unsigned char dmy;

	SCI3.SSR.BYTE = SCI3.SSR.BYTE & 0x87;	//G[tONA
	dmy = SCI3.RDR;							//_~[[h
}

/************************************************************************
	SCI3 M
************************************************************************/
void rxdata_sci3(void)
{
	put_rxbuf(SCI3.RDR);	//f[^RxBufɃXgA
}

/************************************************************************
	1Mi|[Oj
-------------------------------------------------------------------------
		txdata		Mf[^
************************************************************************/
void txone(unsigned char txdata)
{
	while(SCI3.SSR.BIT.TDRE == 0){}		//M\܂ő҂
	SCI3.TDR=txdata;
}

/************************************************************************
	1Mi|[Oj
-------------------------------------------------------------------------
	߂l	Mf[^
************************************************************************/
unsigned char rxone(void)
{
	while(SCI3.SSR.BIT.RDRF == 0){}		//M܂ő҂
	return SCI3.RDR;
}

/************************************************************************
	^C}B1 CjVCY
************************************************************************/
void init_tmb1(void)
{
	TB1.TMB1.BYTE		=	0xf9;	//I[g[hCNbN/2048
	TB1.TLB1			=	0-97;	//=10ms(100Hz)
	IRR2.BIT.IRRTB1		=	0;		//^C}B1ݗvtO NA
	IENR2.BIT.IENTB1	=	1;		//^C}B1ݗvCl[u
}

/************************************************************************
	^C}B1 (10ms)
************************************************************************/
#pragma regsave (intprog_tmb1)
void intprog_tmb1(void)
{
	//^C}B1ݗvtO NA
	IRR2.BIT.IRRTB1 = 0;
	//\tgEFA^C} T0
	if (TimT0.Status==1 || TimT0.Status==2){
		dec_soft_timer(&TimT0,T0/10);
	}
	//\tgEFA^C} T1
	if (TimT1.Status==1 || TimT1.Status==2){
		dec_soft_timer(&TimT1,T1/10);
	}
	//\tgEFA^C} T2
	if (TimT2.Status==1 || TimT2.Status==2){
		dec_soft_timer(&TimT2,T2/10);
	}
	//\tgEFA^C} T3
	if (TimT3.Status==1 || TimT3.Status==2){
		dec_soft_timer(&TimT3,T3/10);
	}
	//\tgEFA^C} T4
	if (TimT4.Status==1 || TimT4.Status==2){
		dec_soft_timer(&TimT4,T4/10);
	}
	//\tgEFA^C} T5
	if (TimT5.Status==1 || TimT5.Status==2){
		dec_soft_timer(&TimT5,T5/10);
	}
	//\tgEFA^C} T6
	if (TimT6.Status==1 || TimT6.Status==2){
		dec_soft_timer(&TimT6,T6/10);
	}
	//\tgEFA^C} T7
	if (TimT7.Status==1 || TimT7.Status==2){
		dec_soft_timer(&TimT7,T7/10);
	}
}

/************************************************************************
	\tgEFA^C}̃fNg
-------------------------------------------------------------------------
			*pst		\tgEFA^C}\̂̃|C^
			initial		^C}JE^̏l
************************************************************************/
void dec_soft_timer(struct SoftTimer *pst,unsigned int initial)
{
	if (pst->Status==1){			//^C}X^[gw
		pst->Status	=	2;			//JEgZbg
		pst->Count	=	initial;	//^C}JE^
	}
	pst->Count--;	//JE^-1
	if (pst->Count==0)				//JE^0ɂȂ
		pst->Status	=	3;			//JEgIZbg
}

/************************************************************************
	\tgEFA^C}̃CjVCY
************************************************************************/
void init_soft_timer(void)
{
	TimT0.Status = 0; TimT1.Status = 0; TimT2.Status = 0; TimT3.Status = 0;
	TimT4.Status = 0; TimT5.Status = 0; TimT6.Status = 0; TimT7.Status = 0;
}

/************************************************************************
	I/O|[g CjVCY
************************************************************************/
void init_io(void)
{
	IO.PCR7			=	_00000000B;	//|[g7,P70-77

//	IO.PCR6			=	_11111111B;	//|[g6,P60-67o
}

/************************************************************************
	ASCIIHEX ϊ
************************************************************************/
unsigned char asc2hex(unsigned int asc_dt)
{
	unsigned char hex_dt,d;

	d = (unsigned char)(asc_dt / 0x0100) - 0x30;
	if (d>9) {d = d - 7;}
	hex_dt = d * 0x10;
	d = (unsigned char)(asc_dt & 0x00ff) - 0x30;
	if (d>9) {d = d - 7;}
	hex_dt = hex_dt + d;

	return hex_dt;
}

/************************************************************************
	HEXASCII ϊ
************************************************************************/
unsigned int hex2asc(unsigned char hex_dt)
{
	unsigned int asc_dt,d;

	d = (unsigned int)(hex_dt / 0x10) + 0x30;
	if (d>0x39) {d = d + 7;}
	asc_dt = d * 0x100;
	d = (unsigned int)(hex_dt & 0x0f) + 0x30;
	if (d>0x39) {d = d + 7;}
	asc_dt = asc_dt + d;

	return asc_dt;
}

/************************************************************************
	EFCg
************************************************************************/
void wait(void)
{
	unsigned long i;

	for (i=0;i<1666666;i++){}
}
