/***********************************************************************/
/*                                                                     */
/*  FILE        :ir_remocon_send.c                                     */
/*  DATE        :Wed, Sep 09, 2009                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3687                                               */
/*                                                                     */
/*  This file is programed by TOYO-LINX Co.,Ltd. / yKikuchi            */
/*                                                                     */
/***********************************************************************/

/************************************************************************
	XCb`̕ѕƃ|[gԍ̑Ή
-------------------------------------------------------------------------
        +-----+
        | SW4 |
        |(P17)|
        +-----+                    +-----+ +-----+
                                   | SW1 | | SW2 |
                                   |(P51)| |(P53)|
        +-----+                    +-----+ +-----+
        | SW3 |
        |(P15)|
        +-----+
************************************************************************/

/************************************************************************
	CN[ht@C
************************************************************************/
#include	<machine.h>		//H8L̖߂g
#include	"iodefine.h"	//I/Õx`
#include	"binary.h"		//C2ig߂̒`

/************************************************************************
	萔̒`iڎwj
************************************************************************/
#define		OK			0		//߂l
#define		NG			-1		//߂l

#define		SW_MODE		1		//XCb`͂ɂԊOo̓[h
								// 0:PƃXCb`
								//  SW1-31h,SW2-32h,SW3-33h,SW4-34h
								// 1:XCb`(IDŒ=4xh)
								//  bit0=SW1
								//  bit1=SW2
								//  bit2=SW3
								//  bit3=SW4
								//  bit4=0
								//  bit5=0
								//  bit6=1
								//  bit7=0
								// 2:XCb`(ID)
								//  bit0=SW1
								//  bit1=SW2
								//  bit2=SW3
								//  bit3=SW4
								//  bit4=ID_bit0
								//  bit5=ID_bit1
								//  bit6=ID_bir2
								//  bit7=ID_bit3

/************************************************************************
	萔GA̒`(ROM)
************************************************************************/
//									  0         1         2         3
//									  0123456789012345678901234567890
const char StartChkCnstData[32]	=	{"TOYO-LINX Co.,Ltd. IR-Send     "};

/************************************************************************
	O[oϐ̒`ƃCjVCY(RAM)
************************************************************************/
// XCb`͂Ɋ֌Wϐ -------------------------------------------
unsigned char	SwData1		=	0;	//t@[Xg[h
unsigned char	SwData2		=	0;	//_u[hɂ茈肵f[^
unsigned char	SwData3		=	0;	//Õ_u[hŌ肵f[^
unsigned char	SwData4		=	0;	//01ɕωf[^
unsigned char	SwStatus	=	0;	//XCb`̓Xe[^X
									// 0:t@[Xg[h
									// 1:_u[h

// IDɊ֌Wϐ -----------------------------------------------------
unsigned char	IDNo		=	0;	//IDԍ

// X^[gʂɊ֌Wϐ -------------------------------------------
char			StartChkData[32];	//X^[gʃf[^

/************************************************************************
	֐̒`
************************************************************************/
void		button(unsigned char);
void		button1(void);
void		button2(void);
void		button3(void);
void		button4(void);
void		buttonID(unsigned char);
void		id_set(void);
void		init_io(void);
void		init_tmv(void);
void		intprog_tmv(void);
void		led_disp(unsigned char);
void		main(void);
char		start_check(void);
void		switch_in(void);

void		IR_sig_out(char);	//AZu֐̒`

/************************************************************************
	CvO
************************************************************************/
void main(void)
{
	// CjVCY ----------------------------------------------------
	init_io();
	init_tmv();

	id_set();

	if (SW_MODE==2){
		while((IO.PDR1.BIT.B7==0)
		    ||(IO.PDR1.BIT.B5==0)
			||(IO.PDR5.BIT.B3==0)
			||(IO.PDR5.BIT.B1==0))	{}	//XCb`SIt܂ő҂
	}

	// C[v -----------------------------------------------------
	while(1){
		if (SW_MODE==0){		//PƃXCb`̓[h
			if      ((SwData2 & 0x02)==0x02){	//{^1ꂽ
				button1();
				SwData4 = 0;
			}
			else if ((SwData2 & 0x08)==0x08){	//{^2ꂽ
				button2();
				SwData4 = 0;
			}
			else if ((SwData2 & 0x20)==0x20){	//{^3ꂽ
				button3();
				SwData4 = 0;
			}
			else if ((SwData2 & 0x80)==0x80){	//{^4ꂽ
				button4();
				SwData4 = 0;
			}
		}
		else if (SW_MODE==1){	//XCb`̓[h(IDŒ)
			if ((SwData2 & _10101010B)!=0){
				button(SwData2);
				SwData4 = 0;
			}
			else{
				IO.PDR6.BYTE = _11111110B;
			}
		}
		else if (SW_MODE==2){	//XCb`̓[h(ID)
			if ((SwData2 & _10101010B)!=0){
				buttonID(SwData2);
				SwData4 = 0;
			}
			else{
				IO.PDR6.BYTE = _11111110B;
			}
		}
	}
}

/************************************************************************
	{^P
************************************************************************/
void button1(void)
{
	IR_sig_out(0x31);
}

/************************************************************************
	{^Q
************************************************************************/
void button2(void)
{
	IR_sig_out(0x32);
}

/************************************************************************
	{^R
************************************************************************/
void button3(void)
{
	IR_sig_out(0x33);
}

/************************************************************************
	{^S
************************************************************************/
void button4(void)
{
	IR_sig_out(0x34);
}

/************************************************************************
	{^/,ŒID
************************************************************************/
void button(unsigned char sw)
{
	unsigned char d = 0;
	
	if ((sw & 0x02)==0x02)	{d = d | _00000001B;}
	if ((sw & 0x08)==0x08)	{d = d | _00000010B;}
	if ((sw & 0x20)==0x20)	{d = d | _00000100B;}
	if ((sw & 0x80)==0x80)	{d = d | _00001000B;}
	IR_sig_out(d | 0x40);	//ŒIDt
	led_disp(d);
}

/************************************************************************
	{^/,ID
************************************************************************/
void buttonID(unsigned char sw)
{
	unsigned char d = 0;
	
	if ((sw & 0x02)==0x02)	{d = d | _00000001B;}
	if ((sw & 0x08)==0x08)	{d = d | _00000010B;}
	if ((sw & 0x20)==0x20)	{d = d | _00000100B;}
	if ((sw & 0x80)==0x80)	{d = d | _00001000B;}
	IR_sig_out(d | IDNo);	//IDt
	led_disp(d);
}

/************************************************************************
	LED\(Port6)
************************************************************************/
void led_disp(unsigned char sw)
{
	unsigned char pd6_temp1;
	unsigned char pd6_temp2;

	pd6_temp1 =  IO.PDR6.BYTE & _00000001B;
	pd6_temp2 = ~IO.PDR6.BYTE & _11111110B;

	if ((sw & 0x01)==0x01){
		if (pd6_temp2==0){
			pd6_temp2 = _00000010B;
		}
		else{
			pd6_temp2 = pd6_temp2 << 1;
			if (pd6_temp2==0){
				pd6_temp2 = _00000010B;
			}
		}
	}
	else if ((sw & 0x02)==0x02){
		if (pd6_temp2==0){
			pd6_temp2 = _10000000B;
		}
		else{
			pd6_temp2 = pd6_temp2 >> 1;
			if (pd6_temp2==_00000001B){
				pd6_temp2 = _10000000B;
			}
		}
	}
	else if ((sw & 0x04)==0x04)	{pd6_temp2 = _00000000B;}
	else if ((sw & 0x08)==0x08)	{pd6_temp2 = _00000000B;}
	else						{pd6_temp2 = _00000000B;}

	IO.PDR6.BYTE = pd6_temp1 | (~pd6_temp2 & _11111110B);
}

/************************************************************************
	I/O|[g CjVCY
************************************************************************/
void init_io(void)
{
	IO.PMR1.BYTE	=	0x00;	//|[g1,ėpo̓|[g
	IO.PUCR1.BYTE	=	0xff;	//|[g1,vAbvI
	IO.PCR1			=	0x00;	//|[g1,P10-P17

	IO.PMR5.BYTE	=	0x00;	//|[g5,ėpo̓|[g
	IO.PUCR5.BYTE	=	0xff;	//|[g5,vAbvI
	IO.PCR5			=	0x00;	//|[g5,P50-P57

	IO.PCR6			=	0xff;	//|[g6,P60-P67o
	IO.PDR6.BYTE	=	0xfe;	//|[g6,o͐ݒ
}

/************************************************************************
	^C}V CjVCY
************************************************************************/
void init_tmv(void)
{
	TV.TCSRV.BYTE	=	0x00;	//TOMV[q͎gȂ
	TV.TCORA		=	156;	//=2ms(156/156.25KHz=1ms)
	TV.TCRV1.BYTE	=	0x01;	//TRGVgK͋֎~,
	TV.TCRV0.BYTE	=	0x4b;	//RyA}b`A ݃Cl[u
								//RyA}b`A TCNTVNA
								//NbN/128(20MHz/128=156.25KHz)
}

/************************************************************************
	^C}V (1ms)
************************************************************************/
#pragma regsave (intprog_tmv)
void intprog_tmv(void)
{
	//RyA}b`tOA NA
	TV.TCSRV.BIT.CMFA = 0;

	//XCb`
	switch_in();
}

/************************************************************************
	XCb`
************************************************************************/
void switch_in(void)
{
	switch(SwStatus){
		case 0:
			SwData1 = (~IO.PDR1.BYTE & _10100000B) | (~IO.PDR5.BYTE & _00001010B);
			if (SwData1!=0)	{SwStatus = 1;}
			else			{SwData2 = SwData3 =0;}
			break;
		case 1:
			if (SwData1==((~IO.PDR1.BYTE & _10100000B) | (~IO.PDR5.BYTE & _00001010B))){
				SwData2 = SwData1;
				SwData4 = SwData4 | (SwData2 & (~SwData3));
				SwData3 = SwData2;
			}
			SwStatus = 0;
			break;
	}
}

/************************************************************************
	IDԍZbg
************************************************************************/
void id_set(void)
{
	if ((start_check()==-1)||(IDNo==0)){
		if		(IO.PDR1.BIT.B7==0)	{IDNo = _10000000B;}
		else if	(IO.PDR1.BIT.B5==0)	{IDNo = _01000000B;}
		else if	(IO.PDR5.BIT.B3==0)	{IDNo = _00100000B;}
		else if	(IO.PDR5.BIT.B1==0)	{IDNo = _00010000B;}
		else						{IDNo = _00000000B;}
	}
}

/************************************************************************
	X^[g`FbN
************************************************************************/
char start_check(void)
{
	char i,j;
	
	for(i=0; i<32; i++){
		if (StartChkData[i]=!StartChkCnstData[i]){
			for(j=0; j<32; j++) {StartChkData[j] = StartChkCnstData[j];}
			return -1;	//R[hX^[g
		}
	}
	
	return 0;	//EH[X^[g
}
