;------------------------------------------------------------------------
;                                                                       |
;   FILE        :akira_01asm                                            |
;   DATE        :Wed, Feb 10, 2010                                      |
;   DESCRIPTION :Main Program                                           |
;   CPU TYPE    :PIC12F683                                              |
;                                                                       |
;   This file is programed by TOYO-LINX Co.,Ltd. / yKikuchi             |
;                                                                       |
;------------------------------------------------------------------------

;------------------------------------------------------------------------
;ԊORf[^MƁCMXCb`ɉLED_B
;@RFVEQ0487iNATIONALj
;@@@@@@@LED2 LED1 LED0
;@@@@ 0    0    1
;@@Đ@@@ 0    1    0
;@@߂@@ 0    1    1
;@@R}@ 1    0    0
;@@~@@@ 1    0    1
;@@ꎞ~@ 1    1    0
;
;@I/Os̊蓖
;@@GP0@LED0
;@@GP1@VAo
;@@GP2@ԊOR
;@@GP3@gp,͐p
;@@GP4@LED1
;@@GP5@LED2
;------------------------------------------------------------------------

	list      p=12f683
	#include <p12f683.inc>

	__CONFIG	_FCMEN_ON & _IESO_ON & _BOD_ON & _CPD_OFF & _CP_OFF & _MCLRE_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT

	RADIX	DEC

;************************************************************************
;	Constant Diffinition
;************************************************************************
IR		equ		GP2		;IR Signal Bit
TIMING	equ		GP0		;Timig Check Signal

;************************************************************************
;	Data Memory
;************************************************************************
	UDATA	20h
ircmd1		RES		1	;IR Command
ircmd2		RES		1	;IR Command
ircmd3		RES		1	;IR Command
ircode		RES		1	;IR Signal Code
ircnt		RES		1	;IR Receive Counter

txdata		RES		1	;Transimt Data
txcnt		RES		1	;Transmit Counter
tx_tmp		RES		1	;Test Program Data

wait_tmp		RES		1	;Wait Counter
wait_tmp2		RES		1	;Wait Counter No.2

cmdcnt		RES		1	;Command Counter
tblcnt		RES		1	;Table Counter

offcnt		RES		2	;LED Off Counter

;************************************************************************
;	Program Memory
;************************************************************************
	ORG	0000h
	GOTO	start

	ORG	0004h

;************************************************************************
;	Initialize
;************************************************************************
	ORG	0010h
start
	BSF		STATUS,RP0	;Bank=1
	MOVLW	01111000b		;Internal OSC 8MHz
	MOVWF	OSCCON
	BCF		STATUS,RP0	;Bank=0
	MOVLW	000010b		;GPIO Initial Out
	MOVWF	GPIO
	MOVLW	07h			;Comparator Off(Use I/O Pin)
	MOVWF	CMCON0
	BSF		STATUS,RP0	;Bank=1
	CLRF	ANSEL		;Analog Input Off(Use I/O Pin)
	MOVLW	001100b		;GP2,3=Input / GP0,1,4,5=Output
	MOVWF	TRISIO
	MOVLW	01111111b		;GPIO Pull Up On
	MOVWF	OPTION_REG
	BCF		STATUS,RP0	;Bank=0

;************************************************************************
;	Main Program
;************************************************************************
main
	CLRWDT

	BTFSC	GPIO,IR		;Leader Code
	GOTO	main_13
	CALL	check_leader
	SUBLW	01h
	BTFSS	STATUS,Z
	GOTO	main_13

	CALL	getcode		;Data-1
	MOVF	ircode,W
	MOVWF	ircmd1

	CALL	getcode		;Data-2
	MOVF	ircode,W
	MOVWF	ircmd2

	CALL	getcode2		;Data-3
	BCF		STATUS,C
	RRF		ircode,F
	BCF		STATUS,C
	RRF		ircode,F
	MOVF	ircode,W
	MOVWF	ircmd3

main_10
	MOVLW	8
	MOVWF	cmdcnt
main_11
	MOVF	cmdcnt,W
	SUBLW	8
	MOVWF	tblcnt
	BCF		STATUS,C
	RLF		tblcnt,F
	BCF		STATUS,C
	RLF		tblcnt,F

	MOVF	tblcnt,W
	CALL	getcmd
	SUBWF	ircmd1,W
	BTFSS	STATUS,Z
	GOTO	main_12
	INCF	tblcnt,F
	MOVF	tblcnt,W
	CALL	getcmd
	SUBWF	ircmd2,W
	BTFSS	STATUS,Z
	GOTO	main_12
	INCF	tblcnt,F
	MOVF	tblcnt,W
	CALL	getcmd
	SUBWF	ircmd3,W
	BTFSS	STATUS,Z
	GOTO	main_12
	INCF	tblcnt,F
	MOVF	tblcnt,W
	CALL	getcmd
	MOVWF	txdata
	MOVF	GPIO,W
	ANDLW	b'000110'
	IORWF	txdata,W
	MOVWF	GPIO
	CALL	txone

	MOVLW	h'ff'
	MOVWF	offcnt
	MOVLW	h'80'
	MOVWF	offcnt+1

	GOTO	main

main_12
	DECF	cmdcnt,F
	btfss	STATUS,Z
	GOTO	main_11
main_13
	DECF	offcnt,F
	btfss	STATUS,Z
	GOTO	main
	DECF	offcnt+1,F
	btfss	STATUS,Z
	GOTO	main
	MOVLW	h'ff'
	MOVWF	offcnt
	MOVLW	h'80'
	MOVWF	offcnt+1
	BCF		GPIO,0
	BCF		GPIO,4
	BCF		GPIO,5
	GOTO	main

;------------------------------------------------------------------------
main_20
	MOVF	ircmd1,W		;Transmit Command Data-1
	MOVWF	txdata
	CALL	txone
	MOVF	ircmd2,W		;Transmit Command Data-2
	MOVWF	txdata
	CALL	txone
	MOVF	ircmd3,W		;Transmit Command Data-3
	MOVWF	txdata
	CALL	txone

	GOTO	main


;************************************************************************
;	Get Command Data
;************************************************************************
getcmd
	ADDWF	PCL,F

	RETLW	h'62'		;
	RETLW	h'E8'
	RETLW	h'3C'
	RETLW	b'000001'

	RETLW	h'42'		;Đ
	RETLW	h'E9'
	RETLW	h'35'
	RETLW	b'010000'

	RETLW	h'42'		;߂
	RETLW	h'E8'
	RETLW	h'3D'
	RETLW	b'010001'

	RETLW	h'82'		;R}
	RETLW	h'E9'
	RETLW	h'33'
	RETLW	b'100000'

	RETLW	h'02'		;~
	RETLW	h'E8'
	RETLW	h'3F'
	RETLW	b'100001'

	RETLW	h'C2'		;ꎞ~/Î~
	RETLW	h'E8'
	RETLW	h'39'
	RETLW	b'110000'

	RETLW	h'00'		;
	RETLW	h'00'
	RETLW	h'00'
	RETLW	b'110001'

	RETLW	h'00'		;
	RETLW	h'00'
	RETLW	h'00'
	RETLW	b'000000'


;************************************************************************
;	Check IR Leader Signal
;************************************************************************
check_leader
	MOVLW	100
	MOVWF	wait_tmp
check_leader_01
	BTFSC	GPIO,IR
	GOTO	check_leader_40
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	DECFSZ	wait_tmp,F
	GOTO	check_leader_01
		
	MOVLW	84
	MOVWF	wait_tmp
check_leader_11
	BTFSC	GPIO,IR
	GOTO	check_leader_21
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	DECFSZ	wait_tmp,F
	GOTO	check_leader_11
	GOTO	check_leader_40

check_leader_21
	MOVLW	237
	MOVWF	wait_tmp
check_leader_22
	BTFSS	GPIO,IR
	GOTO	check_leader_40
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	DECFSZ	wait_tmp,F
	GOTO	check_leader_22

	MOVLW	78
	MOVWF	wait_tmp
check_leader_31
	BTFSS	GPIO,IR
	RETLW	01h			;IR Leader Signal Get
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	DECFSZ	wait_tmp,F
	GOTO	check_leader_31
	GOTO	check_leader_40

check_leader_40
	RETLW	00h			;IR Leader Signal NG

;************************************************************************
;	Get IR Signal Code
;************************************************************************
getcode
	MOVLW	8
getcode_00
	MOVWF	ircnt
	CLRF	ircode
		
getcode_01
	BTFSS	GPIO,IR
	GOTO	$-1

;	BSF		GPIO,TIMING
	CALL	wait15bit
;	BCF		GPIO,TIMING
		
	BTFSC	GPIO,IR
	GOTO	getcode_03
	BCF		STATUS,C
	RRF		ircode,F
getcode_02
	DECFSZ	ircnt,F
	GOTO	getcode_01
	RETURN
getcode_03
	BSF		STATUS,C
	RRF		ircode,F
		
	BTFSC	GPIO,IR
	GOTO	$-1
	GOTO	getcode_02

getcode2
	MOVLW	6
	GOTO	getcode_00

;************************************************************************
;	Wait 1.5bit(IR Signal)
;************************************************************************
wait15bit
	MOVLW	120			;IR Signal 1.5bit(1.2ms)
	MOVWF	wait_tmp
wait15bit_01
	CLRWDT
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	DECFSZ	wait_tmp,F
	GOTO	wait15bit_01
	RETURN

;************************************************************************
;	Transmit 1-Charactor
;************************************************************************
TXD		equ		GP1		;TXD Bit

txone
	MOVLW	8
	MOVWF	txcnt

	BCF		GPIO,TXD		;Start Bit
	CALL	wait1bit

txone_01
	RRF		txdata,F		;Data Bit
	BTFSC	STATUS,C
	GOTO	txone_02
	BCF		GPIO,TXD
	GOTO	txone_03
txone_02
	BSF		GPIO,TXD
	NOP
txone_03
	CALL	wait1bit
	DECFSZ	txcnt,F
	GOTO	txone_01

	BSF		GPIO,TXD		;Stop Bit(2bit)
	CALL	wait1bit
	CALL	wait1bit

	RETURN

;************************************************************************
;	Wait 1-bit
;************************************************************************
wait1bit
	MOVLW	10			;38400 baud
	MOVWF	wait_tmp
wait1bit_01
	CLRWDT
	DECFSZ	wait_tmp,F
	GOTO	wait1bit_01
	RETURN

;************************************************************************
;	Wait Timer
;************************************************************************
wait1ms
	MOVLW	249			;1ms
	MOVWF	wait_tmp
wait1ms_01
	CLRWDT
	GOTO	$+1
	GOTO	$+1
	DECFSZ	wait_tmp,F
	GOTO	wait1ms_01
	RETURN
	
wait100ms
	MOVLW	100			;100ms
wait100ms_00
	MOVWF	wait_tmp2
wait100ms_01
	CALL	wait1ms
	DECFSZ	wait_tmp2,F
	GOTO	wait100ms_01
	RETURN

wait200ms
	MOVLW	200			;200ms
	GOTO	wait100ms_00


;************************************************************************
	END
